//############################################################################//
//Made in 2010-2015 by Artyom Litvinovich
//############################################################################//
//DS1307 Register Address
//Second: ds1307_addr[0]
//Minute: ds1307_addr[1]
//Hour  : ds1307_addr[2]
//Day   : ds1307_addr[3]
//Date  : ds1307_addr[4]
//Month : ds1307_addr[5]
//Year  : ds1307_addr[6]
//#define HOUR_24 0
//#define HOUR_12 1
//############################################################################//
#define DS1307_ID 0xD0
byte rtc_data[8];
byte rtp_br=twi_100_8;
//############################################################################//
//const char weekday[] PROGMEM="SunMonTueWedThrFriSat";
//const char month[]   PROGMEM="JanFebMarAprMayJunJulAugSepOctNovDec";
//const char weekday[] PROGMEM="";
//const char month[]   PROGMEM="";
//############################################################################//
byte rtc_base(byte addr,byte *st)
{
 twi_speed(rtp_br);
 twi_start();            if(twi_get_status()!=0x08){twi_stop();*st=twi_get_status();return 1;}
 twi_write(DS1307_ID|0); if(twi_get_status()!=0x18){twi_stop();*st=twi_get_status();return 2;}
 twi_write(addr);        if(twi_get_status()!=0x28){twi_stop();*st=twi_get_status();return 4;}

 *st=0;
 return 0;
}
//############################################################################//
byte rtc_read_byte(byte addr,byte *data,byte *st)
{
 byte r=rtc_base(addr,st); 
 if (r)return r;
 twi_start();            if(twi_get_status()!=0x10){twi_stop();*st=twi_get_status();return 5;}
 twi_write(DS1307_ID|1); if(twi_get_status()!=0x40){twi_stop();*st=twi_get_status();return 6;}
 *data=twi_read_nack();  if(twi_get_status()!=0x58){twi_stop();*st=twi_get_status();return 7;}
 twi_stop();

 *st=0;
 return 0;
}
//############################################################################//
byte rtc_write_byte(byte addr,byte data,byte *st)
{
 byte r=rtc_base(addr,st); 
 if (r)return r;
 twi_write(data);
 if (twi_get_status()!=0x28){twi_stop();*st=twi_get_status();return 5;}
 twi_stop();

 *st=0;
 return 0;
}
//############################################################################//
byte rtc_read_page(byte page,byte *data,byte *st)
{
 byte i,r;
 word addr=page<<3;
 
 r=rtc_base(addr,st); 
 if (r)return r;
 twi_start();           if(twi_get_status()!=0x10){twi_stop();*st=twi_get_status();return 5;}
 twi_write(DS1307_ID|1);if(twi_get_status()!=0x40){twi_stop();*st=twi_get_status();return 6;}
 for(i=0;i<7;i++){
  *data++ =twi_read_ack();
  if(twi_get_status()!=0x50){twi_stop();*st=twi_get_status();return 10+i;}
 } 
 *data=twi_read_nack();   if(twi_get_status()!=0x58){twi_stop();*st=twi_get_status();return 30;}
  
 twi_stop();

 *st=0;
 return 0;
}
//############################################################################//
byte rtc_write_page(byte page,byte *data,byte *st)
{
 byte i,r;
 word addr=page<<3;
 
 r=rtc_base(addr,st); 
 if (r)return r;
 for(i=0;i<7;i++){
  twi_write(*data++);
  if(twi_get_status()!=0x28){twi_stop();*st=twi_get_status();return 10+i;}
 }
 twi_stop();

 *st=0;
 return 0;
}
//############################################################################//
void reinit_rtc(void)
{
 rtc_data[0]=0x00; //Second
 rtc_data[1]=0x28; //minute
 rtc_data[2]=0x01; //Hour
 
 rtc_data[3]=0x06; //Weekday
 rtc_data[4]=0x20; //Day
 rtc_data[5]=0x12; //Month
 rtc_data[6]=0x14; //Year-2000
 
 rtc_data[7]=0x03;
 
 byte s;
 rtc_write_page(0,rtc_data,&s);
}
//############################################################################//