//############################################################################//
//Made in 2010-2015 by Artyom Litvinovich
//############################################################################//
#if defined(__AVR_ATmega88__) || defined(__AVR_ATmega168__) || defined(__AVR_ATmega328P__)
 #define RX_VECT USART_RX_vect
#elif defined(__AVR_ATmega1284P__)
 #define RX_VECT USART0_RX_vect
#else
 #error unknown MCU serial
#endif
//############################################################################//   
#define rx_buf_siz 240
volatile byte rx_buf[rx_buf_siz];
volatile word rx_pos_r;
volatile word rx_pos_w;
volatile word rx_siz;
volatile byte ser_report=0;
volatile byte ser_x;
//############################################################################// 
inline void usart_write_byte(byte data)
{
 while(!(UCSR0A & (1<<UDRE0))){}
 UDR0=data;
}
//############################################################################// 
inline void usart_write_word(word data)
{
 usart_write_byte(data&0xFF);
 usart_write_byte(data>>8);
}
//############################################################################// 
void usart_write_str(char *str)
{
 while (*str)usart_write_byte(*str++);
}
//############################################################################// 
void usart_write_buf(byte *buf, int len)
{
 int i;
 for(i=0;i<len;i++)usart_write_byte(buf[i]);
}
//############################################################################//                                                                 
ISR(RX_VECT)
{
 if(((rx_pos_w+1)==rx_pos_r)||((rx_pos_r==0) && (rx_pos_w==(rx_buf_siz-1)))){
  ser_x=UDR0;
  if(ser_report)usart_write_byte(0);
  return;
 }
 rx_buf[rx_pos_w]=UDR0;
 rx_pos_w++;
 if(rx_pos_w>=rx_buf_siz)rx_pos_w=0;
 rx_siz--;
 if (ser_report)usart_write_byte(rx_siz);
}
//############################################################################//   
byte usart_got_byte(void)
{
 return rx_pos_r!=rx_pos_w;
}
//############################################################################//
byte usart_read_byte(void)
{
 byte res;
 while(rx_pos_r==rx_pos_w){}
 cli();
 res=rx_buf[rx_pos_r];
 rx_pos_r++;
 if(rx_pos_r>=rx_buf_siz)rx_pos_r=0;
 rx_siz++;
 sei();
 return res;
}
//############################################################################// 
byte usart_peek_byte(void)
{
 byte res;
 while(rx_pos_r==rx_pos_w){}
 cli();
 res=rx_buf[rx_pos_r];
 sei();
 return res;
}
//############################################################################// 
void usart_init(word ubrr_value)
{
 rx_pos_r=0;
 rx_pos_w=0;
 rx_siz=rx_buf_siz;
 UBRR0L=ubrr_value;
 UBRR0H=(ubrr_value>>8);

 UCSR0C=(3<<UCSZ00);
 UCSR0A=0;
 UCSR0B=(1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0);
}
//############################################################################// 
void usart_deinit(void)
{
 UCSR0C=(3<<UCSZ00);
 UCSR0A=0;
 UCSR0B=0;
}
//############################################################################// 
