//############################################################################//
//Made in 2010-2015 by Artyom Litvinovich
//############################################################################//
#define VCMD_READ_DATA            0x30
#define VCMD_WRITE_DATA           0x31
#define VCMD_READ_FBUF            0x32
#define VCMD_FBUF_CTRL            0x36
#define VCMD_GET_FBUF_LEN         0x34
#define VCMD_POWER_SAVE_CTRL      0x3E
#define VCMD_AE_CTRL              0x40
/*
VCMD_GEN_VERSION          =$11;
VCMD_SET_SERIAL_NUMBER    =$21;
VCMD_SET_PORT             =$24;
VCMD_SYSTEM_RESET         =$26;
VCMD_READ_DATA            =$30;
VCMD_WRITE_DATA           =$31;
VCMD_READ_FBUF            =$32;
VCMD_WRITE_FBUF           =$33;
VCMD_GET_FBUF_LEN         =$34;
VCMD_SET_FBUF_LEN         =$35;
VCMD_FBUF_CTRL            =$36;
VCMD_COMM_MOTION_CTRL     =$37;
VCMD_COMM_MOTION_STATUS   =$38;
VCMD_COMM_MOTION_DETECTED =$39;
VCMD_MIRROR_CTRL          =$3A;
VCMD_MIRROR_STATUS        =$3B;
VCMD_COLOR_CTRL           =$3C;
VCMD_COLOR_STATUS         =$3D;
VCMD_POWER_SAVE_CTRL      =$3E;
VCMD_POWER_SAVE_STATUS    =$3F;
VCMD_AE_CTRL              =$40;
VCMD_AE_STATUS            =$41;
VCMD_MOTION_CTRL          =$42;
VCMD_MOTION_STATUS        =$43;
VCMD_TV_OUT_CTRL          =$44;
VCMD_OSD_ADD_CHAR         =$45;
VCMD_DOWNSIZE_CTRL        =$54;
VCMD_DOWNSIZE_STATUS      =$55;
VCMD_GET_FLASH_SIZE       =$60;
VCMD_ERASE_FLASH_SECTOR   =$61;
VCMD_ERASE_FLASH_ALL      =$62;
VCMD_READ_LOGO            =$70;
VCMD_SET_BITMAP           =$71;
VCMD_BATCH_WRITE          =$80;  
*/
//############################################################################//
#define VCWD_CHIP_REG 1
//############################################################################//
dword tedw(dword d){return ((d&0xFF000000UL)>>24UL)|((d&0x00FF0000UL)>>8UL)|((d&0x0000FF00UL)<<8UL)|((d&0x000000FFUL)<<24UL);}
word tew(word d){return ((d&0xFF00)>>8)|((d&0x00FF)<<8);}
//############################################################################//
volatile dword time; //Assumes WDT IRQ with time++
//############################################################################//
void cc_wait_status(void)
{
 byte res[5];
 byte c,len;
 
 c=0;
 len=5;
 time=0;
 while(c<len){
  if (usart_got_byte())res[c++]=usart_read_byte();
  if (time>33UL) break;
 } 
}
//############################################################################//
void cc_flush(void)
{
 volatile byte r;
 byte c;
 
 c=0;
 time=0;
 while(c<100){
  sei();
  if (usart_got_byte()){
   c++;
   r=usart_read_byte();
  }
  if (time>11UL) break;
 }
}
//############################################################################//
byte cc_get_byte(void)
{
 byte res[6];
 byte c,len;
 
 c=0;
 len=6;
 time=0;
 while(c<len){
  if (usart_got_byte())res[c++]=usart_read_byte();
  if (time>33UL) break;
 }
 
 return res[5];
}
//############################################################################//
dword cc_get_dword(void)
{
 byte res[9];
 byte c,len;
 
 c=0;
 len=9;
 time=0;
 while(c<len){
  if (usart_got_byte())res[c++]=usart_read_byte();
  if (time>33UL) break;
 }
 
 return * ((dword*)(&res[5]));
}
//############################################################################//
void send_buf(byte cmd,byte *buf,byte bs)
{
 byte pbuf[4];
 
 pbuf[0]=0x56;
 pbuf[1]=0;
 pbuf[2]=cmd;
 pbuf[3]=bs;
    
 usart_send_buf(&pbuf[0],4);
 usart_send_buf(&buf[0],bs);
}
//############################################################################//
//############################################################################//
void cc_set_comp(byte comp)
{
 byte buf[5];
 
 buf[0]=VCWD_CHIP_REG;
 buf[1]=0x01;
 buf[2]=0x12;
 buf[3]=0x04;   
 buf[4]=comp;
 
 send_buf(VCMD_WRITE_DATA,&buf[0],5);
 cc_wait_status();
}
//############################################################################//
byte cc_get_comp(void)
{
 byte buf[4];
 
 buf[0]=VCWD_CHIP_REG;
 buf[1]=0x01;
 buf[2]=0x12;
 buf[3]=0x04;
 
 send_buf(VCMD_READ_DATA,&buf[0],4);
 return cc_get_byte();
}
//############################################################################//
void cc_set_ps(void)
{
 byte buf[3];
 
 buf[0]=0;
 buf[1]=1;
 buf[2]=1;
 
 send_buf(VCMD_POWER_SAVE_CTRL,&buf[0],3);
 cc_wait_status();
} 
//############################################################################//
void cc_clear_ps(void)
{
 byte buf[3];
 
 buf[0]=0;
 buf[1]=1;
 buf[2]=0;
 
 send_buf(VCMD_POWER_SAVE_CTRL,&buf[0],3);
 cc_wait_status();
}      
//############################################################################//
//0:stop current frame
//1:stop next frame
//2:resume frame
//3:step frame
void do_send_fbuf(byte b)
{
 send_buf(VCMD_FBUF_CTRL,&b,1);  
 cc_wait_status();
}       
//############################################################################//
void cc_frame_run (void){do_send_fbuf(3);}
void cc_frame_lock(void){do_send_fbuf(1);}
//############################################################################//    
//0:50/60Hz flicker:
//  0:50Hz
//  1:60Hz
//1:auto indoor:
//  0:automatically step indoor and outdoor
//  1:forcibly step indoor
//2:backlight compensation:
//  0:stop backlight compensation
//  1:start backlight compensation
void set_ae_param(byte pr,byte v)
{
 byte b[3];
 
 b[0]=pr;
 b[1]=1;   //0=gpio, 1=uart
 b[2]=v;
 
 send_buf(VCMD_AE_CTRL,&b[0],3);  
 cc_wait_status();
}
//############################################################################//
void cc_set_50hz        (void){set_ae_param(0x00,0x00);}
void cc_set_60hz        (void){set_ae_param(0x00,0x01);}
void cc_set_indoor_auto (void){set_ae_param(0x01,0x00);}
void cc_set_force_indoor(void){set_ae_param(0x01,0x01);}
void cc_set_blc_stop    (void){set_ae_param(0x02,0x00);}
void cc_set_blc_start   (void){set_ae_param(0x02,0x01);}
//############################################################################//
dword cc_ask_len(void)
{
 byte b=0;
 
 send_buf(VCMD_GET_FBUF_LEN,&b,1);
 return tedw(cc_get_dword());
} 
//############################################################################//
void cc_ask_data(dword pos,word sz)
{
 byte buf[12];
 word c;
 
 buf[0]=0;
 buf[1]=0x0A; 
 * ((dword*)(&buf[2]))=tedw(pos);
 * ((dword*)(&buf[6]))=tedw(sz);
 * ((word*)(&buf[10]))=tew(10);

 send_buf(VCMD_READ_FBUF,&buf[0],12);
 
 c=0;
 time=0;
 while(c<(sz+10)){
  if (usart_got_byte())fbuf[c++]=usart_read_byte();
  if (time>33) break;
 }
}
//############################################################################//