//############################################################################//
//Made in 2010-2015 by Artyom Litvinovich
//############################################################################//   
#define F_CPU 8000000UL
//############################################################################//   
#include <avr/io.h>
#include <util/delay.h>  
#include <avr/power.h>
#include <avr/boot.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
//############################################################################//
#define byte  unsigned char
#define word uint16_t
#define dword uint32_t
#define qword uint64_t
#define int64 int64_t
#define int32 int32_t
//############################################################################//   
#define set_bit(port,bit) port|=(1<<bit)
#define clear_bit(port,bit) port&=~(1<<bit)
//############################################################################//
#define APP_END 0x6FFF
#define PAGESIZE 128

#define SPI_PORT PORTB
#define SPI_DDR  DDRB

#define SPI_MOSI_PIN 3
#define SPI_MISO_PIN 4
#define SPI_CLK_PIN  5

#define DBG_R 5
#define DBG_G 6
//############################################################################//
#include "mmc.h"
#include "pff.h"
//############################################################################//
FATFS fat;
byte fs_res=0xFF;
byte file_res=0xFF;
byte mnt_res=0xFF;
word bytes_read=0;
byte buf[PAGESIZE];
//############################################################################//
void prog(void)
{ 
 word i,p,size;
 
 size=fat.fsize;
 if(size>APP_END)return;
  
 cli();
 
 for(p=0;p<size;p+=PAGESIZE){
  boot_spm_busy_wait();
  boot_page_erase(p);
 }
 boot_spm_busy_wait();
 
 for(p=0;p<size;p+=PAGESIZE){
  pf_read(buf,PAGESIZE,&bytes_read);
  for(i=0;i<PAGESIZE;i+=2){
   if(i+p<size)boot_page_fill(p+i,*(word*)&buf[i]);else boot_page_fill(p+i,0xFFFF);
  }
  boot_page_write(p);
  boot_spm_busy_wait();
 }
 boot_rww_enable();
}
//############################################################################//
void check(void)
{
 fs_res=disk_initialize();
 if (!fs_res)mnt_res=pf_mount(&fat); 
 if (mnt_res==FR_OK)file_res=pf_open("book_upd.avr");
  
 if(file_res!=FR_OK)return;
  
 set_bit(PORTD,DBG_R);
 set_bit(PORTD,DBG_G);
 prog();
 clear_bit(PORTD,DBG_G);
 clear_bit(PORTD,DBG_R);
}
//############################################################################//   
int main(void)
{
 clock_prescale_set(0);
 
 set_bit(DDRB,1);
 clear_bit(PORTB,1);
 
 clear_bit(DDRB,2);
 set_bit(PORTB,2);
 
 set_bit(SPI_DDR,SPI_MOSI_PIN);
 clear_bit(SPI_DDR,SPI_MISO_PIN);
 set_bit(SPI_DDR,SPI_CLK_PIN);
 
 set_bit(DDRC,SD_CS);
 set_bit(PORTC,SD_CS);

 set_bit(DDRD,DBG_R);
 set_bit(DDRD,DBG_G);
 clear_bit(PORTD,DBG_R);
 clear_bit(PORTD,DBG_G);
 
 set_bit(PORTD,DBG_G);
 check();
 clear_bit(PORTD,DBG_G);

 asm("jmp 0000");
 return 0;
}
//############################################################################//   