//############################################################################//
//Made in 2010-2015 by Artyom Litvinovich
//############################################################################//
#define SD_CS 0
#define SD_PORT PORTC
#define SD_DDR DDRC
//############################################################################//
dword get_fattime (void)
{
 return   ((dword)(year - 1980) << 25) //Year
        | ((dword)month  << 21)        //Month
        | ((dword)day    << 16)        //Day
        | ((dword)hour   << 11)        //Hour
        | ((dword)minute << 5)         //Min
        | ((dword)second >> 1);        //Sec
}
//############################################################################//
#include "avrlib/mmc.h"
#include "avrlib/ff.h"
//############################################################################//
char fname[28]="DCIM/IMG0000/IMG_000.JPG\0";
//                      8        17
char dname[28]="DCIM/IMG0000\0";
char cfgname[28]="lapse.txt\0";
FATFS fat;
//############################################################################//
word interval=30;
word dir,fn;
byte the_cmd='.';
//############################################################################//
byte card_init(void)
{
 word i;
 byte fs_res;
 
 //Init the card and mount FS
 set_bit(LED_PORT,LED_G);
 for (i=0;i<3;i++){
  fs_res=disk_initialize(1);
  if (!fs_res){
   f_mount(&fat);
   break;
  }
  if(i>=2){
   clear_bit(LED_PORT,LED_G);
   return 0;
  }
 }
 clear_bit(LED_PORT,LED_G);
 
 return 1;
}
//############################################################################//
byte read_cfg_file(void)
{
 byte file_res,res;
 byte nl;
 word iwr1,iwr2;
 
 word bw;
 FIL f;
 
 interval=30;
 the_cmd='.';
 res=0;
 
 //Open settings file 
 file_res=f_open(&f,cfgname,FA_READ);
 if(file_res==FR_OK){
  set_bit(LED_PORT,LED_R);
  
  f_read(&f,&iwr1,2,&bw);
  f_read(&f,&iwr2,2,&bw);
  f_read(&f,&nl,1,&bw);
  f_read(&f,&fname[8],4,&bw);
  f_read(&f,&nl,1,&bw);
  f_read(&f,&fname[17],3,&bw);
  f_read(&f,&nl,1,&bw);
  f_read(&f,&the_cmd,1,&bw);
  f_read(&f,&nl,1,&bw);
  
  interval=100*(10*((iwr1&0xFF)-'0')+(((iwr1>>8)&0xFF)-'0'))+(10*((iwr2&0xFF)-'0')+(((iwr2>>8)&0xFF)-'0'));
  
  f_close(&f);
  res=1;
 }
 clear_bit(LED_PORT,LED_R);
 
 return res;
}
//############################################################################//
byte write_cfg_file(void)
{
 byte file_res,res;
 byte nl;
 word iwr1,iwr2;
 
 word bw;
 FIL f;
 
 res=0;
 
 iwr1=((((interval%100)/10)%10)+'0')+((((interval%100)%10)+'0')<<8);
 iwr2=((((interval/100)/10)%10)+'0')+((((interval/100)%10)+'0')<<8);
 
 //Update settings file
 file_res=f_open(&f,cfgname,FA_WRITE | FA_CREATE_ALWAYS); 
 if(file_res==FR_OK){
  set_bit(LED_PORT,LED_G);
  
  nl=0x0A;
  
  f_write(&f,&iwr2,2,&bw);
  f_write(&f,&iwr1,2,&bw);
  f_write(&f,&nl,1,&bw);
  f_write(&f,&fname[8],4,&bw);
  f_write(&f,&nl,1,&bw);
  f_write(&f,&fname[17],3,&bw);
  f_write(&f,&nl,1,&bw);
  f_write(&f,&the_cmd,1,&bw);
  f_write(&f,&nl,1,&bw);
  
  f_close(&f);
  res=1;
 }
 clear_bit(LED_PORT,LED_G);
 
 return res;
}
//############################################################################//
void make_dir(void)
{
 set_bit(LED_PORT,LED_G);
 dname[8]=fname[8];
 dname[9]=fname[9];
 dname[10]=fname[10];
 dname[11]=fname[11];
 f_mkdir(dname);
 clear_bit(LED_PORT,LED_G); 
}
//############################################################################//
byte write_frame(void)
{
 byte res=0;
 byte file_res;
 FIL f;
 word bw;
 
 word sz,rpos,rsz,wrsz,i;
 
 //Open file and write frame
 file_res=f_open(&f,fname,FA_WRITE | FA_CREATE_ALWAYS); // | FA_CREATE_NEW); //Glitch-free operation at cost of missing files in rare cases or total FUBAR.
 if(file_res==FR_OK){
  set_bit(LED_PORT,LED_R);
   
  cc_frame_lock();
  cc_set_ps();
  cc_flush();
  sz=cc_ask_len();
  
  rsz=256;
  for(i=0;i<sz/rsz+1;i++){
   rpos=i*rsz;
   wrsz=rsz;
   if(rpos<sz){
    if(rsz>(sz-rpos))wrsz=sz-rpos;
    cc_ask_data(rpos,rsz);
    f_write(&f,&fbuf[5],wrsz,&bw);
   }
  }

  cc_frame_run();
  f_close(&f);
  res=1;
 }
 clear_bit(LED_PORT,LED_R);
 
 return res;
}
//############################################################################//
void inc_file(void)
{
 //Count up
 dir=(fname[8]-'0')*1000+(fname[9]-'0')*100+(fname[10]-'0')*10+(fname[11]-'0');
 fn=(fname[17]-'0')*100+(fname[18]-'0')*10+(fname[19]-'0');
 
 fn++;
 if(fn>=1000){
  dir++;
  fn=1;
 }
 
 fname[ 8]=(dir/1000)+'0';
 fname[ 9]=((dir/100)%10)+'0';
 fname[10]=((dir/10)%10)+'0';
 fname[11]=((dir/1)%10)+'0';
 
 fname[17]=(fn/100)+'0';
 fname[18]=((fn/10)%10)+'0';
 fname[19]=((fn/1)%10)+'0';
}
//############################################################################//
void sense_file(void)
{
 if (!card_init()) return; 
 if (!read_cfg_file()) return; 
 make_dir(); 
 if (!write_frame()) return; 
 inc_file();
 write_cfg_file();
}
//############################################################################//
