//############################################################################//
//Made in 2010-2015 by Artyom Litvinovich
//############################################################################//  
ISR(WDT_vect)
{
 set_bit(WDTCSR,WDIE);
 time++;
}
//############################################################################//
//############################################################################//
void deinit_spi(void){SPCR=0;SPSR=0;}
//############################################################################//
void camera_init(void)
{
 set_bit(LED_PORT,LED_R);
 
 _delay_ms(100);
 cc_set_50hz();     _delay_ms(10);
 cc_set_comp(0x35); _delay_ms(10);
 cc_frame_run();    _delay_ms(10);
 cc_clear_ps();     _delay_ms(10);
 cc_set_comp(0x35); _delay_ms(10);
 cc_flush();
 cc_set_comp(0x35); _delay_ms(10);
 cc_flush();
 
 clear_bit(LED_PORT,LED_R);
}
//############################################################################//
void init_pwr(void)
{
 //SD card CS back to ok
 set_bit(SD_PORT,SD_CS);
 
 //Power up
 clear_bit(PWR_PORT,PWR_PIN);
 
 //UART
 set_bit(DDRD,1);
 usart_init(8);
 UCSR0A=(1<<U2X0);
 
 //Init camera
 camera_init();
}
//############################################################################//
void deinit_pwr(void)
{
 //Power off
 set_bit(PWR_PORT,PWR_PIN);
 
 //Clear UART
 usart_deinit();
 clear_bit(DDRD,1);

 //SD card CS down to 0
 clear_bit(SD_PORT,SD_CS);
}
//############################################################################//  
void set_pins(void)
{
 //LEDs
 set_bit(LED_DDR,LED_R);
 set_bit(LED_DDR,LED_G);
 
 //UART TX
 clear_bit(DDRD,1);
 
 //PWR off
 set_bit(PWR_DDR,PWR_PIN);
 set_bit(PWR_PORT,PWR_PIN);
 
 //SPI cleared
 SPCR=0;
 SPSR=0;
 set_bit  (SPI_DDR,SPI_MOSI);
 clear_bit(SPI_DDR,SPI_MISO);
 set_bit  (SPI_DDR,SPI_SCK);  
 clear_bit(SPI_PORT,SPI_MOSI);
 clear_bit(SPI_PORT,SPI_SCK);
 
 //SD card CS (low, since power is off)
 set_bit(SD_DDR,SD_CS);
 clear_bit(SD_PORT,SD_CS);
}
//############################################################################//  
void set_wdt(void)
{
 wdt_reset(); 
 wdt_enable(WDTO_15MS);
 set_bit(WDTCSR,WDIE);
 set_sleep_mode(SLEEP_MODE_PWR_DOWN);
}
//############################################################################//  
#define blink(t) set_bit(LED_PORT,LED_R);_delay_ms(t);clear_bit(LED_PORT,LED_R);_delay_ms(t);
//############################################################################//  
void setup(void)
{
 //OSCCAL=171; ///FIXME: Board-specific!  Breadboard, measured, was 163
 //OSCCAL=169; ///FIXME: Board-specific!  First board, estimated
 //OSCCAL=67; ///FIXME: Board-specific! Second board, was 66
 OSCCAL=167; ///FIXME: Board-specific!  Third board, measured, was 160
 
 clock_prescale_set(0);
 
 //Off the HW
 power_adc_disable();
 
 //Set all pins to a clear state
 set_pins();

 //Watchdog, every 15ms
 sei();
 set_wdt();
 
 //Power on for SD and camera
 init_pwr();
 
 blink(100);
 
 //RTC
 twi_init(rtp_br);
}
//############################################################################//
void sleep_wait(int sec)
{
 int cnt,lim;
 cnt=0;
 lim=sec*66;
 while(cnt++ < lim){
  sleep_enable();
  sleep_cpu();  
 } 
}
//############################################################################//
void full_sleep(int sec)
{
 deinit_pwr();
 deinit_spi();
 sleep_wait(sec);
 init_pwr();
}
//############################################################################//  
