@echo off
PATH=L:\soft\WinAVR\bin;L:\soft\WinAVR\utils\bin;%PATH%
set tgt=camera
rem set cff=-mmcu=atmega168 -I. -gdwarf-2 -Os -funsigned-char -funsigned-bitfields -fpack-struct -fshort-enums -Wall -Wstrict-prototypes -std=gnu99
set cff=-mmcu=atmega328p -I. -std=gnu99 -W -Wall -pedantic -Wstrict-prototypes -Wundef -funsigned-char -funsigned-bitfields -ffunction-sections -fpack-struct -fshort-enums -ffreestanding -Os -g -gdwarf-2 --combine -fwhole-program -fno-inline-small-functions 

del %tgt%.hex

avr-gcc %cff% %tgt%.c --output %tgt%.elf -lm  2>gcc.log
avr-objcopy -O ihex -R .eeprom -R .fuse -R .lock -R .signature %tgt%.elf %tgt%.hex
avr-objcopy -j .eeprom --set-section-flags=.eeprom="alloc,load" --change-section-lma .eeprom=0 --no-change-warnings -O ihex %tgt%.elf %tgt%.eep || exit 0

avr-strip %tgt%.elf
avr-size -A %tgt%.elf
hex2bin.exe %tgt%.hex
del %tgt%.elf %tgt%.o %tgt%.eep %tgt%.hex
move %tgt%.hex.bin book_upd.avr

pause